@warnings
@name Boolean Cut

main{
	//debug();
	selmode(USER);
	
	//Variables!
	var tmp, poly_sel;
	var fgl, bgl, wkl;
	
	//Requires that I get the foreground and background layers.
	//Get Foreground Layer
	tmp = lyrfg();
	fgl = tmp[1];
	//Get Background Layer
	tmp = lyrbg();
	bgl = tmp[1];
	//And an empty layer to use as a scratch pad.
	tmp = lyrempty();
	wkl = tmp[1];
	//Set our layers,
	setlayers(fgl,bgl);	
	
	//Get the selected polygon ID's, in a down and dirty fashion.
	editbegin();
		poly_sel = polygons;
	editend();
	
	//Clear the original selection, if any
	selpolygon(CLEAR);
	//Reselect it.
	//This is to catch the case of use everything, ie, nothing selected.
	//Has to be selected for copy() to work properly.
	selpolygon(SET,POLYID,poly_sel);
	
	//Prep work done, Begin the actual operation!
	undogroupbegin();
	//Copy the original mesh, as this requires two separate
	//Boolean Ops to do.
	
	//Intersect foreground and background, merge points.
		copy();
		setlayers(wkl,bgl);
		paste();
		boolean(INTERSECT);
		mergepoints();
	//Cut background volume from forground object, and merge points.
		setlayers(fgl,bgl);
		boolean(SUBTRACT);
		mergepoints();
	//now copy the intersected volume back into the foreground layer.
		lyrsetfg(wkl);
		cut();
		lyrsetfg(fgl);
		paste();
		setlayers(fgl,bgl);
	undogroupend();
}

setlayers: w_fore, w_back
{
	//Sets foreground and background layers, nothing more...
	lyrsetfg(w_fore);
	lyrsetbg(w_back);
}