@warnings
@name Honeycomb

main{
	var cc = sqrt(.75);
	var rd = 0.010;
	var p = <0,0,0>;
	var v = nil;
	
	var cl = 4;
	var rw = 4;
	
	reqbegin("Make Hex Grid");
		c1 = ctlinteger("Rows : ", rw);
		c2 = ctlinteger("Columns : ", cl);
		c3 = ctldistance("Radius : ", rd);
	
		return if !reqpost();
		
		rw = getvalue(c1);
		cl = getvalue(c2);
		rd = getvalue(c3);
	
	reqend();

		undogroupbegin();
	editbegin();
		for(row=0; row<rw; row++){
			for(col = 0; col<cl; col++){
				bs = (1.5 * rd) * col;
				bt = (cc * (rd * 2)) * row + ((col % 2) * (cc * rd));
				v = nil;
				p = <bs,0,bt + cc * rd>;
				v += addpoint(p);
				
				p += <rd/2,0,cc * rd>;
				v += addpoint(p);
		
				p += <rd,0,0>;
				v += addpoint(p);
		
				p += <rd / 2,0,-cc * rd>;
				v += addpoint(p);
		
				p += <-rd / 2,0,-cc * rd>;
				v += addpoint(p);
		
				p += <-rd,0,0>;
				v += addpoint(p);
		
				addpolygon(v);
			}
		}		
	editend();
	mergepoints();
	undogroupend();

}