@warnings
@name Quad Sphere

main{
	var a[6],b[8];
	var c[4];
	l = 2;
	r = 1.0	;
	selmode(USER);
	reqbegin("Quad Sphere 1.0");
		c1 = ctlinteger("Level :", l);
		c2 = ctldistance("Radius :", r);

		return if !reqpost();
		
		l = getvalue(c1);
		r = getvalue(c2);
	reqend();
	
	undogroupbegin();
		editbegin();
			b[1] = addpoint(<-r, r, r>);b[2] = addpoint(<-r, r,-r>); 
			b[3] = addpoint(<-r,-r,-r>);b[4] = addpoint(<-r,-r, r>);
			b[5] = addpoint(< r, r, r>);b[6] = addpoint(< r, r,-r>); 
			b[7] = addpoint(< r,-r,-r>);b[8] = addpoint(< r,-r, r>);
			//X Plane
			a[1] = crazy_poly(b[1],b[2],b[3],b[4]);
			a[2] = crazy_poly(b[8],b[7],b[6],b[5]);
			//Y Plane
			a[3] = crazy_poly(b[3],b[7],b[8],b[4]);
			a[4] = crazy_poly(b[1],b[5],b[6],b[2]);
			//Z Plane
			a[5] = crazy_poly(b[3],b[2],b[6],b[7]);
			a[6] = crazy_poly(b[8],b[5],b[1],b[4]);
		editend();
		
		selpolygon(CLEAR);
		selpolygon(SET,POLYID,a);
	
		for(i=l; i > 0;i--) subdivide(FLAT);
	
		editbegin();
			foreach(v,points) pointmove(v,r * normalize(pointinfo(v)));
		editend();
	undogroupend();
}

crazy_poly : q_p1, q_p2, q_p3, q_p4
{
	var c[4];
	var retv = -1;
	c[1] = q_p1;
	c[2] = q_p2;
	c[3] = q_p3;
	c[4] = q_p4;
	retv = addpolygon(c);
	return(retv);
}